<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/03/2004 *
 * ===============                              Last change: 10/03/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : birthday_confirm.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Birthday bonus confirmation link                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Geburtstagsgutschrift bestaetigen                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require_once("inc/libs/security_functions.php");

// Init "action" and "what"
global $what, $action;
$GLOBALS['what'] = ""; $GLOBALS['action'] = "";

// Set module
$GLOBALS['module'] = "birthday_confirm"; $CSS = -1;

// Load the required file(s)
require("inc/config.php");

// Is the "birthday" extension active?
if (!EXT_IS_ACTIVE("birthday")) {
	// Redirect to index
	LOAD_URL("modules.php?module=index&amp;msg=".CODE_EXTENSION_PROBLEM."&amp;ext=birthday");
} // END - if

// Is the script installed?
if (isBooleanConstantAndTrue('mxchange_installed')) {
	// Script is installed so let's check for his confirmation link...
	$uid = bigintval($_GET['uid']);

	// Only allow numbers here...
	$chk = bigintval($_GET['check'], false);

	// Check if link is not clicked so far
	$result = SQL_QUERY_ESC("SELECT b.points, d.gender, d.surname, d.family, d.status, d.ref_payout
FROM "._MYSQL_PREFIX."_user_birthday AS b
INNER JOIN `"._MYSQL_PREFIX."_user_data` AS d
ON b.userid=d.userid
WHERE b.userid=%s AND b.chk_value='%s' LIMIT 1",
 array($uid, $chk), __FILE__, __LINE__);
	//* DEBUG: */ echo "uid=".$uid.",chk=".$chk." (".strlen($chk)."/".strlen($_GET['check'])."/".SQL_NUMROWS($result).")<br />\n";

	// Is an entry there?
	if (SQL_NUMROWS($result) == 1) {
		// Ok, congratulation again! Here's your gift from us...
		$data = SQL_FETCHARRAY($result, false);

		// Is the account confirmed?
		if ($data['status'] == "CONFIRMED") {
			// Set mode depending on how many mails the member has to confirm
			$locked = false;
			if (($data['ref_payout'] > 0) && ($_CONFIG['allow_direct_pay'] == "N")) $locked = true;

			// Add points to account
			unset($DEPTH);
			ADD_POINTS_REFSYSTEM("birthday_confirm", $uid, $data['points'], false, "0", $locked, strtolower($_CONFIG['birthday_mode']));

			// Remove entry from table
			$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_user_birthday WHERE userid=%s AND chk_value='%s' LIMIT 1",
			 array($uid, $chk), __FILE__, __LINE__);

			// Update mediadata if version is 0.0.4 or newer
			if (GET_EXT_VERSION("mediadata") >= "0.0.4") {
				// Update database
				MEDIA_UPDATE_ENTRY(array("total_points"), "add", $data['points']);
			}

			// Transfer data to constants for the template
			define('__GENDER', TRANSLATE_GENDER($data['gender']));
			define('__SNAME', $data['surname']);
			define('__FNAME', $data['family']);
			define('__GIFT' , $data['points']);

			// Load message from template
			define('__MSG', LOAD_TEMPLATE("birthday_msg", true));
		} else {
			// Unconfirmed / locked accounts cannot get points
			define('__MSG', BIRTHDAY_CANNOT_STATUS_1.TRANSLATE_STATUS($data['status']).BIRTHDAY_CANNOT_STATUS_2);
		}
	} else {
		// Cannot load data!
		define('__MSG', BIRTHDAY_CANNOT_LOAD_DATA);
	}

	// Free memory
	SQL_FREERESULT($result);

	// Set this because we have no module in URI
	$GLOBALS['module'] = "birthday_confirm";

	// Include header
	include(PATH."inc/header.php");

	// Load birthday header template (for your banners, e.g.?)
	define('__BIRTHDAY_HEADER', LOAD_TEMPLATE("birthday_header", true));

	// Load birthday footer template (for your banners, e.g.?)
	define('__BIRTHDAY_FOOTER', LOAD_TEMPLATE("birthday_footer", true));

	// Load final template and output it
	LOAD_TEMPLATE("birthday_confirm");

	// Include footer
	include(PATH."inc/footer.php");
} else {
	// You have to configure first!
	LOAD_URL("install.php");
}
// Really all done here... ;-)
?>
