<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/29/2004 *
 * ===============                              Last change: 11/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : autopurge.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Automatical purging of outdated mail links       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auto-Loeschung von veralteten Mail-Links         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} // END - if

// Abort if autopurge is not active or disabled by admin
if ((!EXT_IS_ACTIVE("autopurge")) || ($_CONFIG['auto_purge_active'] == "N")) {
	// Abort here
	return false;
} // END - if

// Search for mails from deleted members?
if ($_CONFIG['ap_del_mails'] == "Y") {
	// Okay, let's check for them...
	$since = bigintval($_CONFIG['ap_dm_timeout']);
	$result_mails = SQL_QUERY_ESC("SELECT sender\
FROM "._MYSQL_PREFIX."_pool
WHERE data_type='DELETED' AND timestamp <= (UNIX_TIMESTAMP() - %s)
ORDER BY sender ASC",
	 array($since), __FILE__, __LINE__);

	// Reset counter...
	$DELETED = 0;

	// Do we have "purged" mails?
	if (SQL_NUMROWS($result_mails) > 0) {
		// Okay, check for their sender's
		while(list($sender) = SQL_FETCHROW($result_mails)) {
			// Check now...
			$fount = SQL_NUMROWS(SQL_QUERY_ESC("SELECT userid FROM `"._MYSQL_PREFIX."_user_data` WHERE userid=%s LIMIT 1",
				array(bigintval($sender)), __FILE__, __LINE__));
			if ($found == 0) {
				// Okay we found some mails!
				$result_remove = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_pool WHERE sender=%s",
					array(bigintval($sender)), __FILE__, __LINE__);
				$DELETED += SQL_AFFECTEDROWS();

				// Reset query (to prevent possible errors) ...
				$since = bigintval($_CONFIG['ap_dm_timeout']);
				$result_mails = SQL_QUERY_ESC("SELECT sender
FROM "._MYSQL_PREFIX."_pool
WHERE data_type='DELETED' AND timestamp <= (UNIX_TIMESTAMP() - %s)
ORDER BY sender ASC",
					array($since), __FILE__, __LINE__);
			}
		}
	}

	// Free memory
	SQL_FREERESULT($result_mails);

	// Now let's check for stats entries as well
	$since = bigintval($_CONFIG['ap_dm_timeout']);
	$result_mails = SQL_QUERY_ESC("SELECT sender
FROM "._MYSQL_PREFIX."_user_stats
WHERE data_type='DELETED' AND timestamp_send <= (UNIX_TIMESTAMP() - %s)
ORDER BY sender ASC",
		array($since), __FILE__, __LINE__);

	// Do we have "purged" mails?
	if (SQL_NUMROWS($result_mails) > 0) {
		// Okay, check for their sender's
		while(list($sender) = SQL_FETCHROW($result_mails)) {
			// Check now...
			$found = SQL_NUMROWS(SQL_QUERY_ESC("SELECT userid FROM `"._MYSQL_PREFIX."_user_data` WHERE userid=%s LIMIT 1", array(bigintval($sender)), __FILE__, __LINE__));
			if ($found == 0) {
				// Okay we found some mails!
				$result_remove = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_user_stats WHERE sender=%s", array(bigintval($sender)), __FILE__, __LINE__);
				$DELETED += SQL_AFFECTEDROWS();

				// Reset query (to prevent possible errors) ...
				$since = bigintval($_CONFIG['ap_dm_timeout']);
				$result_mails = SQL_QUERY_ESC("SELECT sender
FROM "._MYSQL_PREFIX."_user_stats
WHERE data_type='DELETED' AND timestamp_send <= (UNIX_TIMESTAMP() - %s)
ORDER BY sender ASC",
					array($since), __FILE__, __LINE__);
			}
		}
	}

	// Free memory
	SQL_FREERESULT($result_mails);

	// Do we have deleted mails and the admin want's to receive a notification
	if (($DELETED > 0) && ($_CONFIG['ap_dm_notify'] == "Y")) {
		// Send out email to admin
		SEND_ADMIN_NOTIFICATION(AUTOPURGE_ADMIN_DEL_MAILS_SUBJECT, "admin_autopurge_del_mails", $DELETED, "");
	}
}

//
?>
