<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/20/2005 *
 * ================                             Last change: 03/20/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-themes.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Theme selection for members                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Design-Auswahl fuer Mitglieder                   *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL("modules.php?module=index");
} elseif ((!EXT_IS_ACTIVE("theme")) && (!IS_ADMIN())) {
	ADD_FATAL(EXTENSION_PROBLEM_EXT_INACTIVE, "theme");
	return;
}

// Add description as navigation point
ADD_DESCR("member", __FILE__);

if (!empty($_POST['member_theme'])) {
	// Save theme to member's profile
	$result = SQL_QUERY_ESC("UPDATE `"._MYSQL_PREFIX."_user_data` SET curr_theme='%s' WHERE userid=%s LIMIT 1",
	  array($_POST['member_theme'], $GLOBALS['userid']), __FILE__, __LINE__);

	// Set new theme for guests
	$newTheme = SQL_ESCAPE($_POST['member_theme']);

	// Change to new theme
	set_session("mxchange_theme", $newTheme);

	// Theme saved!
	LOAD_TEMPLATE("admin_settings_saved", false, MEMBER_THEME_SAVED);
}

// Initialize array
$THEMES = array(
	'theme_unix'   => array(), // Unix name from filesystem
	'theme_name'   => array(), // Title
	'theme_author' => array(), // Theme author's name
	'theme_email'  => array(), // Author's email address
	'theme_url'    => array(), // URL were you can download it from
	'theme_ver'    => array(), // Version number of theme
);

// Read directory "themes"
$handle = opendir(PATH."theme/") or mxchange_die("Cannot read themes dir!");
while ($entry = readdir($handle)) {
	// Construct absolute theme.php file name
	$theme = sprintf("%stheme/%s/theme.php", PATH, $entry);

	if (($entry != ".") && ($entry != "..") && (FILE_READABLE($theme)) && (THEME_IS_ACTIVE($entry))) {
		// Found a valid directory so let's load it's theme.php file
		include($theme);

		// Add found theme to array
		$THEMES['theme_unix'][]   = $entry;
		$THEMES['theme_name'][]   = $THEME_NAME;
		$THEMES['theme_author'][] = $THEME_AUTHOR;
		$THEMES['theme_email'][]  = $THEME_EMAIL;
		$THEMES['theme_url'][]    = $THEME_URL;
		$THEMES['theme_ver'][]    = $THEME_VERSION;
	} // END - if
} // END - while

// Close directory
closedir($handle);

// Sort array by Uni* name
array_pk_sort($THEMES, array("theme_name"));

// Generate output lines for the template
$OUT = ""; $SW = 2;
foreach ($THEMES['theme_unix'] as $key => $unix) {
	$default = "";
	if (get_session('mxchange_theme') == $unix) $default = " checked selected";

	// Add row
	$OUT .= "<TR>
  <TD class=\"switch_sw".$SW." bottom2 right2\" align=\"center\" height=\"30\">
    <INPUT type=\"radio\" name=\"member_theme\" class=\"member_normal\" value=\"".$unix."\"".$default.">
  </TD>
  <TD class=\"switch_sw".$SW." bottom2 right2\" align=\"center\">".$THEMES['theme_name'][$key]."</TD>
  <TD class=\"switch_sw".$SW." bottom2 right2\" align=\"center\">
    <A href=\"mailto:".$THEMES['theme_email'][$key]."?Subject=[Theme:] ".$THEMES['theme_name'][$key]." (".$unix.")"."\">".$THEMES['theme_author'][$key]."</A>
  </TD>
  <TD class=\"switch_sw".$SW." bottom2 right2\" align=\"center\">
    <A href=\"".DEREFERER($THEMES['theme_url'][$key])."\" target=\"_blank\">".$THEMES['theme_url'][$key]."</A>
  </TD>
  <TD class=\"switch_sw".$SW." bottom2\" align=\"center\">v".$THEMES['theme_ver'][$key]."</TD>
</TR>\n";
	$SW = 3 - $SW;
}

if (empty($OUT)) {
 	// No themes found???
	$OUT = "<TR>
  <TD colspan=\"5\" class=\"bottom2\" height=\"80\">
    ".LOAD_TEMPLATE("admin_settings_saved", true, MEMBER_NO_THEMES_FOUND)."
  </TD>
</TR>\n";
}
define('__THEME_LIST', $OUT);

// Load template
LOAD_TEMPLATE("member_themes");

//
?>
