<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/29/2004 *
 * ===============                              Last change: 04/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : profile-updte.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Sends out notifications to keep profiles updated *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet Erinnerngen aus, damit die Profile        *
 *                     von den Mitgliedern aktuell gehalten werden      *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

if (($_CONFIG['send_prof_update'] == "Y") && ($_CONFIG['profile_update'] > 0) && ($_CONFIG['resend_profile_update'])) {
	// Load personal data              0      1     2      3        4          5         6
	$result = SQL_QUERY_ESC("SELECT userid, email, gender, surname, family, last_update, joined
FROM
	"._MYSQL_PREFIX."_user_data
WHERE
	(last_update < (UNIX_TIMESTAMP() - %s) AND last_update != 0 AND last_profile_sent < (UNIX_TIMESTAMP() - %s))
OR
	(last_update=0 AND last_profile_sent=0 AND joined < (UNIX_TIMESTAMP() - %s))
ORDER BY userid", array($_CONFIG['profile_update'], $_CONFIG['resend_profile_update'], $_CONFIG['profile_update']), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0)
	{
		// We need to send-out notifications...
		while ($DATA = SQL_FETCHROW($result))
		{
			$DATA[6] = MAKE_DATETIME($DATA[6], "0");
			if (round($DATA[5]) == "0")
			{
				// Has never changed his accont
				$DATA[5] = PROFILE_NEVER_CHANGED;
			}
			 else
			{
				// Has changed his account
				$DATA[5] = MAKE_DATETIME($DATA[5], "0");
			}

			// Load email template and send mail away
			$msg = LOAD_EMAIL_TEMPLATE("profile-updte", "", bigintval($DATA[0]));
			SEND_EMAIL($DATA[1], PROFILE_OUTDATED, $msg);

			// Update profile data
			$result_update = SQL_QUERY_ESC("UPDATE `"._MYSQL_PREFIX."_user_data` SET last_profile_sent=UNIX_TIMESTAMP(), notified='Y' WHERE userid=%s LIMIT 1",
			 array(bigintval($DATA[0])), __FILE__, __LINE__);
		}
	}

	// Free result
	SQL_FREERESULT($result);
}
//
?>
